[Leetcode] 274. H-Index 解题报告

来源:互联网 发布:身份证图像识别 java 编辑:程序博客网 时间:2024/06/15 03:15

题目

Given an array of citations (each citation is a non-negative integer) of a researcher, write a function to compute the researcher's h-index.

According to the definition of h-index on Wikipedia: "A scientist has index h if h of his/her N papers have at least h citations each, and the other N − h papers have no more than h citations each."

For example, given citations = [3, 0, 6, 1, 5], which means the researcher has 5 papers in total and each of them had received 3, 0, 6, 1, 5 citations respectively. Since the researcher has 3 papers with at least 3 citations each and the remaining two with no more than 3 citations each, his h-index is 3.

Note: If there are several possible values for h, the maximum one is taken as the h-index.

思路

1、排序法:最简单的解决方法是首先对citations进行排序,然后逆序扫描。这种算法的时间复杂度是O(nlogn),空间复杂度是O(1)。

2、哈希表法:利用空间换时间的做法,则可以将时间复杂度降低到O(n)。这种做法的思路是根据h-index的范围是[0, citations.size()],因此我们只需要从高到低统计引用数比当前index大的论文数量。如果当前论文数量比index大了,说明这个index就是h-index,也就是最多有index篇论文,满足每篇引用数不低于index,此时就可以直接返回了。

代码

1、排序法:

class Solution {public:    int hIndex(vector<int>& citations) {        sort(citations.begin(), citations.end());        int ret = 0, size = citations.size();        for (int i = size - 1; i >= 0; --i) {            if (citations[i] > ret) {                ++ret;            }            else {                break;            }        }        return ret;    }};

2、哈希表法:

class Solution {public:    int hIndex(vector<int>& citations) {        unordered_map<int, int> hash;        int len = citations.size();        for(int i = 0; i < len; ++i) {            if(citations[i] >= len) {                ++hash[len];            }            else {                ++hash[citations[i]];            }        }        for(int i = len; i >= 0; --i) {            hash[i] += hash[i+1];            if(i <= hash[i]) {                return i;            }        }        return 0;    }};

原创粉丝点击